#
# spec file for package jakarta-tomcat (Version 4.0.1)
#
# Copyright (c) 2002 SuSE Linux AG, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# please send bugfixes or comments to feedback@suse.de.
#

# neededforbuild  apache-devel-packages compat java2
# usedforbuild    aaa_base aaa_dir aaa_version base bash bindutil bison bzip cpio cpp cyrus-sasl db devs diffutils e2fsprogs file fileutils findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm gppshare grep groff gzip kbd less m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg pam-devel pam-modules patch ps rcs readline sendmail sh-utils shadow strace syslogd sysvinit texinfo textutils timezone unzip util-linux vim apache apache-devel autoconf automake binutils compat cracklib expat gcc gdbm gettext java2 libtool libz mm mod_ssl openssl pam perl rpm

Name:         jakarta-tomcat
%define       webapp_root webapp-module-1.0.1-tc401
%define	      jakarta_root /opt/jakarta
%define       apache_sysconfdir %(apxs -q SYSCONFDIR)
Version:      4.0.1
Release:      227
License:      Other License(s), see package
Summary:      The servlet container
Group:        Productivity/Networking/Web/Frontends
URL:          http://jakarta.apache.org
Provides:     jakarta tomcat
Obsoletes:    jakarta
Requires:     sdk1.2.x
Autoreqprov:  on
Source0:      %{name}-%{version}.tar.bz2
Source1:      webapp-module-1.0.1-tc401-src.tar.bz2
Source2:      config.tar.gz
Source3:      6772.tar.gz
Source4:      InvokerServlet.java
Patch0:       %{name}-%{version}.patch
Patch1:       %{name}-%{version}-8.0.patch
Patch2:       %{name}-%{version}-InvokerServlet.patch
BuildRoot:    %{_tmppath}/%{name}-%{version}-build

%description
Tomcat is the servlet container that is used in the official Reference
Implementation for the Java Servlet and JavaServer Pages technologies.
The Java Servlet and JavaServer Pages pecifications are developed 
by Sun under the Java Community Process. 


Authors:
--------
    Hans Bergsten <hans@gefionsoftware.com>
    James Duncan <Davidson duncan@x180.com>
    Pierpaolo Fumagalli <pier@apache.org>
    Craig McClanahan <cmcclanahan@mytownnet.com>
    Sam Ruby <rubys@us.ibm.com>
    Jon Stevens <jon@clearink.com>
    Anil Vijendran <akv@eng.sun.com>
    Brian Behlendorf <brian@behlendorf.com>
    Kevin Burton <burton@relativity.yi.org>
    Danno Ferrin <shemnon@earthlink.net>
    Jason Hunter <jh@servlets.com>
    Ramesh Mandava <rmandava@talentportal.com>
    Stefano Mazzocchi <stefano@apache.org>
    Rajiv Mordani <mode@chinet.com>
    Harish Prabhandham <harishp@onebox.com>
    Jean-Luc Rochat <shachor@il.ibm.com>
    James Todd <jwtodd@pacbell.net>

SuSE series: n

%prep
%setup -q -b1 -b2 -a3
mkdir -p server/classes/org/apache/catalina/servlets/
cp %{S:4} server/classes/org/apache/catalina/servlets/
#
%patch0
%patch1
%patch2

%build
# InvokerServlet.class with security fix
CLASSPATH="./common/classes:server/classes"
for file in ./common/lib/*.jar ./server/lib/*.jar ; do
  CLASSPATH="$CLASSPATH:$file"
done
export CLASSPATH
echo CLASSPATH=$CLASSPATH
javac server/classes/org/apache/catalina/servlets/InvokerServlet.java
unset CLASSPATH
#
# WebApp module 
cd ../%{webapp_root}
./support/buildconf.sh
CFLAGS="$RPM_OPT_FLAGS -fPIC" \
./configure --with-apxs=/usr/sbin/apxs \
	--with-apr=$RPM_BUILD_DIR/%{webapp_root}/apr \
	--enable-java=/usr/lib/java \
	--with-tomcat=$RPM_BUILD_DIR/%{name}-%{version}
make

%install
rm -rf $RPM_BUILD_ROOT
#
# tomcat
install -m 755 -d $RPM_BUILD_ROOT%{jakarta_root}
cp -rd bin     $RPM_BUILD_ROOT%{jakarta_root}
cp -rd classes $RPM_BUILD_ROOT%{jakarta_root}
cp -rd common  $RPM_BUILD_ROOT%{jakarta_root}
cp -rd conf    $RPM_BUILD_ROOT%{jakarta_root}
cp -rd lib     $RPM_BUILD_ROOT%{jakarta_root}
cp -rd logs    $RPM_BUILD_ROOT%{jakarta_root}
cp -rd server  $RPM_BUILD_ROOT%{jakarta_root}
cp -rd webapps $RPM_BUILD_ROOT%{jakarta_root}
cp -rd work    $RPM_BUILD_ROOT%{jakarta_root}
#
# tomcat documentation
install -m 755 -d $RPM_BUILD_ROOT%{_defaultdocdir}/%{name}
ln -sf %{jakarta_root}/webapps/tomcat-docs $RPM_BUILD_ROOT%{_defaultdocdir}/%{name}/tomcat-docs
install -m 644 LICENSE *.txt $RPM_BUILD_ROOT%{_defaultdocdir}/%{name}
#
# webapp-module
cd $RPM_BUILD_DIR/%{webapp_root}
install -d -m 755 $RPM_BUILD_ROOT/usr/lib/apache/
install apache-1.3/mod_webapp.so $RPM_BUILD_ROOT/usr/lib/apache/
cp java/warp.jar $RPM_BUILD_ROOT/%{jakarta_root}/server/lib/
#
# webapp-module documentation
install -m 755 -d $RPM_BUILD_ROOT%{_defaultdocdir}/%{name}/webapp-module/
cp -r docs $RPM_BUILD_ROOT%{_defaultdocdir}/%{name}/webapp-module/
install -m 644 CHANGES *.txt $RPM_BUILD_ROOT%{_defaultdocdir}/%{name}/webapp-module/
#
# SuSE configuration
cd $RPM_BUILD_DIR/
install -m 755 -d $RPM_BUILD_ROOT%{_var}/adm/fillup-templates/
install -m 755 -d $RPM_BUILD_ROOT/%{apache_sysconfdir}/modules/
install -m 755 -d $RPM_BUILD_ROOT/etc/init.d/
install -m 755 -d $RPM_BUILD_ROOT/%{_sbindir}/
install -m 644 sysconfig.apache-%{name} $RPM_BUILD_ROOT%{_var}/adm/fillup-templates/
install -m 644 sysconfig.%{name}        $RPM_BUILD_ROOT%{_var}/adm/fillup-templates/
install -m 644 tomcat.modules.conf      $RPM_BUILD_ROOT/%{apache_sysconfdir}/modules/tomcat
install -m 644 tomcat.conf              $RPM_BUILD_ROOT/opt/jakarta/conf/
install -m 755 rctomcat                 $RPM_BUILD_ROOT/etc/init.d/tomcat
ln -sf /etc/init.d/tomcat $RPM_BUILD_ROOT%{_sbindir}/rctomcat
#
# SuSE documentation
install -m 644 README.SuSE $RPM_BUILD_ROOT%{_defaultdocdir}/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post
%{fillup_and_insserv -n -s jakarta-tomcat tomcat START_TOMCAT}
%{fillup_only -a -n -s apache %name}

%postun
%{insserv_cleanup}

%files
%defattr(-, root, root)
%doc %{_defaultdocdir}/%{name}
%{_var}/adm/fillup-templates/sysconfig.apache-%{name}
%{_var}/adm/fillup-templates/sysconfig.%{name}
%{apache_sysconfdir}/modules/tomcat
/etc/init.d/tomcat
%{_sbindir}/rctomcat
%{jakarta_root}/bin
%{jakarta_root}/classes
%{jakarta_root}/common
%{jakarta_root}/conf
%{jakarta_root}/lib
%{jakarta_root}/server
%{jakarta_root}/webapps
%attr(-, wwwrun, root) %{jakarta_root}/logs
%attr(-, wwwrun, root) %{jakarta_root}/work
/usr/lib/apache/*

%changelog -n jakarta-tomcat
* Wed Oct 02 2002 - pmladek@suse.cz
- fixed a security bug in the invoker servlet which allowed to see
  unprocessed source of a JSP page or a static resource
- added a new section into README.SuSE about more secure configuration
* Mon May 20 2002 - pmladek@suse.cz
- security fix of request dispatcher to do not allow a remote attacker
  to read files anywhere on the server filesystem (6772.tar.gz)
- removed questionable CLASSPATH patch
- init script fixes owner of working directories /opt/jakarta/logs
  and /opt/jakarta/work to wwwrun:root now
* Tue Feb 26 2002 - pmladek@suse.cz
- fixed configuration for apache
- tomcat daemon is running now as wwwrun instead of as root [#13861]
* Mon Jan 07 2002 - pmladek@suse.cz
- CATALINA_HOME moved from /etc/rc.config to /etc/sysconfig/jakarta-tomcat
- HTTPD_SEC_MOD_TOMCAT moved from /etc/rc.config.d/apache.rc.config
  to /etc/sysconfig/apache
- removed START_TOMCAT variable from /etc/rc.config
* Wed Nov 28 2001 - pmladek@suse.cz
- updated to version 4.0.1
  * servlet container (Catalina) has been developed from the
  ground up for flexibility and performance
  * implemented the final released versions of the Servlet 2.3
  and JSP 1.2 specifications
  * Servlet 2.2 and JSP 1.1 specifications also supported
  with no changes
  * new Apache WebApp Module used to connect a web server
  with Tomcat servlet container
  * JDK 1.2.x or higher is requested
- package renamed from jakarta to jakarta-tomcat because
  Tomcat is only one subproject from the big Jakarta project
- used binary distribution, only apache modul is compiled from sources
- fixed apache configuration, start script and README.SuSE
- removed apache from Requires
* Tue Nov 20 2001 - pmladek@suse.cz
- jre1.1.x replaced with jdk.1.1.x in neededforbuild because
  Tomcat needs java development kit to run
- fixed rctomcat to use always java development kit
- used java2 for building
* Thu Oct 25 2001 - ro@suse.de
- try neededforbuild alias apache-devel-packages
* Thu Sep 13 2001 - pmladek@suse.cz
- fixed rctomcat for all javas
- fixed README.SuSE
* Fri Aug 31 2001 - pmladek@suse.cz
- fixed depencies to other JDKs (#9325):
  * require jre1.1.x instead of java
- tomcat use new modul mod_jk for communication with apache
  and created new configuration file for tomcat
- removed depencies on jserv (old modul for communication with apache)
- created README.SuSE
- config files moved to tar.gz
* Tue Aug 14 2001 - pmladek@suse.cz
- fixed tomcat modul for apache configuration to protect
  conflicts with jserv (bug #8067):
  * modul jserv is loaded and configured only once
- fixed tomcat rc script:
  * tomcat always is started
  * there are still problems to stop tomcat if
  apache is started with modulies tomcat or jserv
* Tue Aug 07 2001 - pmladek@suse.cz
- updated to vesion 3.2.3
  * security and bug fixes
* Tue Jul 17 2001 - pmladek@suse.cz
- updated to version 3.2.2
  * many security fixes
- fixed to compile with package java
  * removed and disabled java2 exetensions
  * tested with java2
- version test for apache and java made less strict
- fixed java_jdkdir
- fixed rights of directories in /otp/jakarta
- fixed documentation in %%{_defaultdocdir}
- cleaned up spec file
* Fri May 11 2001 - pmladek@suse.cz
- moved init script from patch to sources
- fixed tomcat start/stop script:
  * works with /var/run/tomcat.pid now
- fixed tomcat init script:
  * start: no repetitional start
  * stop: it stops tomcat only when it is runing
  * status: it uses /var/run/tomcat.pid
  * probe: added
- set default boot settings to START_TOMCAT=no
- all changes fix bug #8521
* Wed May 09 2001 - cstein@suse.de
- repacked sources with xzip/bzip2 (saved bytes ca. 370 kb)
* Thu Apr 19 2001 - pmladek@suse.cz
- fixed JAVA_HOME
* Mon Apr 09 2001 - pblaha@suse.cz
- update on 3.2.1 and add build root
* Wed Apr 04 2001 - rolf@suse.de
- fixed problem with Apache and Java version detection
* Thu Mar 29 2001 - rolf@suse.de
- added Apache module file so it works with jserv and Apache
- provided init script
* Tue Mar 27 2001 - stepan@suse.de
- fixed to compile on alpha.
* Thu Nov 30 2000 - kukuk@suse.de
- Cleanup neededforbuild
- Remove requires for xpm
* Mon May 29 2000 - uli@suse.de
- added "ulimit -v unlimited" to build/install sections
* Mon May 29 2000 - rolf@suse.de
- 3.1 final
* Thu Apr 13 2000 - ro@suse.de
- patched so java gets along with less memory
* Thu Apr 13 2000 - rolf@suse.de
- fixed a bug for AXP, still doesnt build. JAVA is buggy
* Wed Mar 29 2000 - rolf@suse.de
- version 3.1
